unit unit_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, ExtCtrls, ToolWin, StdCtrls, Buttons, ShellApi,
  unit_uccthread, AppEvnts, Registry, ImgList;

type
  Tfrm_Main = class(TForm)
    pnl_Ctrls: TPanel;
    pnl_Lists: TPanel;
    pnl_Files: TPanel;
    lv_Files: TListView;
    slv_Explorer: TShellListView;
    tv_Explorer: TShellTreeView;
    btn_Add: TBitBtn;
    btn_Remove: TBitBtn;
    btn_UT2003Dir: TBitBtn;
    btn_Compres: TBitBtn;
    btn_Abort: TBitBtn;
    spl_Explorer: TSplitter;
    ed_MaxThread: TLabeledEdit;
    ud_MaxThreads: TUpDown;
    bvl_ThreadsTop: TBevel;
    btn_Thread1: TBitBtn;
    btn_Thread2: TBitBtn;
    btn_Thread3: TBitBtn;
    btn_Thread4: TBitBtn;
    btn_Thread5: TBitBtn;
    btn_Thread6: TBitBtn;
    btn_Thread7: TBitBtn;
    btn_Thread8: TBitBtn;
    btn_Thread9: TBitBtn;
    sb_Status: TStatusBar;
    btn_Exit: TBitBtn;
    Bevel1: TBevel;
    ae_Main: TApplicationEvents;
    spl_Lists: TSplitter;
    il_Files: TImageList;
    btn_UploadSettings: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btn_RemoveClick(Sender: TObject);
    procedure lv_FilesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lv_FilesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure slv_ExplorerChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_UT2003DirClick(Sender: TObject);
    procedure btn_CompresClick(Sender: TObject);
    procedure ae_MainHint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure slv_ExplorerDblClick(Sender: TObject);
    procedure btn_ExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure slv_ExplorerKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_Thread1Click(Sender: TObject);
    procedure btn_Thread2Click(Sender: TObject);
    procedure btn_Thread3Click(Sender: TObject);
    procedure btn_Thread4Click(Sender: TObject);
    procedure btn_Thread5Click(Sender: TObject);
    procedure btn_Thread6Click(Sender: TObject);
    procedure btn_Thread7Click(Sender: TObject);
    procedure btn_Thread8Click(Sender: TObject);
    procedure btn_Thread9Click(Sender: TObject);
    procedure btn_AbortClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure btn_UploadSettingsClick(Sender: TObject);
  private
    procedure WMDropFiles(VAR Msg: TWMDropFiles); message WM_DROPFILES;
  public
    ucc: string;
    procedure AddFile(filename: string);
    procedure ThreadFinished(Sender: TObject);
    procedure updateThreadButton(id: integer; visible: boolean; hint: string);
    procedure AbortThread(id: integer);
  end;

const
  MAXTHREADS = 9;
  UZEXT = '.uz2';

var
  frm_Main: Tfrm_Main;
  working: boolean = false;
  threadsrunning, totalcompress, finished: integer;
  threads: array[0..MAXTHREADS-1] of TUCCThread;

implementation

uses unit_upload;

{$R *.dfm}

procedure Tfrm_Main.AddFile(filename: string);
var
  tmpi: TListItem;
  fs: TFileStream;
begin
  if (working) then exit;
  if (DirectoryExists(filename)) then exit;
  if (FileExists(filename)) then begin
    if (lv_Files.FindCaption(0,filename,false,true,false) <> nil) then exit;
    tmpi := lv_Files.Items.Add;
    tmpi.ImageIndex := 0;
    tmpi.Caption := filename;
    fs := TFileStream.Create(filename,fmOpenRead or fmShareDenyNone);
    try
      tmpi.SubItems.Add(IntToStr(fs.size));
    finally
      fs.Free;
    end;
    tmpi.SubItems.Add('');
    tmpi.SubItems.Add('');
  end;
end;

procedure Tfrm_Main.WMDropFiles(VAR Msg: TWMDropFiles);
var
  N : Longint;
  buffer : array[0..80] of Char;
begin
  with Msg do begin
  	Result := 1;
    for N := 0 to DragQueryFile(Drop, $FFFFFFFF, buffer, 80)-1 do begin
      DragQueryFile(Drop, N, Buffer, 80);
      AddFile(Buffer);
    end;
    DragFinish(Drop);
  end;
end;

procedure Tfrm_Main.ThreadFinished(Sender: TObject);
var
  li: TListItem;
  thread: TUCCThread;
  fs: TFileStream;
  ratio: integer;
begin
  if (Sender is TUCCThread) then begin
    thread := (Sender as TUCCThread);
    threads[thread.threadid] := nil;
    updateThreadButton(thread.threadid, false, '');
    Dec(threadsrunning);
    li := lv_Files.FindCaption(0, thread.filename, false, true, true);
    if (thread.returnvalue = 0) then begin
      fs := TFileStream.Create(thread.filename+UZEXT,fmOpenRead or fmShareDenyNone);
      try
        li.SubItems[1] := IntToStr(fs.Size);
        ratio := Round(fs.Size * 100 / StrToIntDef(li.SubItems[0], 1));
        totalcompress := totalcompress+ratio;
        li.SubItems[2] := IntToStr(ratio)+'%';
      finally
        fs.Free;
      end;
      Inc(finished);
      li.ImageIndex := 1;
    end
    else begin
      if (FileExists(thread.filename+UZEXT)) then Deletefile(thread.filename+UZEXT);
      li.SubItems[1] := 'ERROR';
    end;
    if (lv_Files.Items.Count <> 0) then sb_Status.Panels[1].Text := 'Progress: '+IntToStr(Round(finished * 100 / lv_Files.Items.Count))+'%';
    if (finished <> 0) then sb_Status.Panels[2].Text := 'Compression: '+IntToStr(Round(totalcompress / finished))+'%';
    sb_Status.Panels[3].Text := 'Threads: '+IntToStr(threadsrunning);
    Application.Title := sb_Status.Panels[1].Text;
  end;
  if (threadsrunning = 0) then begin
    Screen.Cursor := crDefault;
    working := false;
    btn_Compres.Enabled := true;
    btn_Abort.Enabled := false;
    btn_Add.Enabled := true;
    btn_Remove.Enabled := true;
    btn_UT2003Dir.Enabled := true;
    Application.Title := Caption;
    if (frm_Upload.cb_UploadAfterCompress.Checked) then begin
      frm_Upload.StartUploading := true;
      frm_Upload.ShowModal;
    end;
  end;
end;

procedure Tfrm_Main.updateThreadButton(id: integer; visible: boolean; hint: string);
var
  btn: TBitBtn;
begin
  case id of
    0: btn := btn_Thread1;
    1: btn := btn_Thread2;
    2: btn := btn_Thread3;
    3: btn := btn_Thread4;
    4: btn := btn_Thread5;
    5: btn := btn_Thread6;
    6: btn := btn_Thread7;
    7: btn := btn_Thread8;
    8: btn := btn_Thread9;
    else exit;
  end;
  btn.Visible := visible;
  btn.Hint := hint;
  btn.Enabled := true;
  Application.ProcessMessages;
end;

procedure Tfrm_Main.AbortThread(id: integer);
begin
  if (threads[id] = nil) then exit;
  TerminateProcess(threads[id].procid,1);
end;

procedure Tfrm_Main.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle, True);
end;

procedure Tfrm_Main.btn_RemoveClick(Sender: TObject);
var
  tmpItem : TListItem;
begin
  if (working) then exit;
  if (lv_Files.Items.Count = 0) then exit;
  lv_Files.Items.BeginUpdate;
  tmpItem := lv_Files.Selected;
  while (tmpItem <> nil) do begin
    tmpItem.Delete;
    tmpItem := lv_Files.GetNextItem(lv_Files.Items.Item[0],sdBelow,[isSelected]);
  end;
  lv_Files.Items.EndUpdate;
end;

procedure Tfrm_Main.lv_FilesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE) then begin
    btn_RemoveClick(Sender);
  end;
end;

procedure Tfrm_Main.lv_FilesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  btn_Remove.Enabled := (lv_Files.SelCount > 0);
  btn_Compres.Enabled := (lv_Files.Items.Count > 0) and (FileExists(ucc));
end;

procedure Tfrm_Main.slv_ExplorerChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  btn_Add.Enabled := (slv_Explorer.SelCount > 0);
end;

procedure Tfrm_Main.btn_AddClick(Sender: TObject);
var
  tmpItem : TListItem;
begin
  if (slv_Explorer.Selected = nil) then exit;
  lv_Files.Items.BeginUpdate;
  tmpItem := slv_Explorer.Selected;
  while (tmpItem <> nil) do begin
    AddFile(slv_Explorer.Folders[tmpItem.Index].PathName);
    tmpItem := slv_Explorer.GetNextItem(tmpItem,sdAll,[isSelected]);
  end;
  sb_Status.Panels[0].Text := 'Files: '+IntToStr(lv_Files.Items.Count);
  lv_Files.Items.EndUpdate;
end;

procedure Tfrm_Main.btn_UT2003DirClick(Sender: TObject);
begin
  PromptForFileName(ucc, 'UCC|ucc.exe', 'exe', 'Locate ucc.exe', ExtractFilePath(ucc));
  btn_Compres.Enabled := (lv_Files.Items.Count > 0) and (FileExists(ucc));
  if (not FileExists(ucc)) then btn_UT2003Dir.Font.Style := [fsBold]
    else btn_UT2003Dir.Font.Style := [];
end;

procedure Tfrm_Main.btn_CompresClick(Sender: TObject);
var
  i,j: integer;
begin
  working := true;
  btn_Compres.Enabled := false;
  btn_Abort.Enabled := true;
  btn_Add.Enabled := false;
  btn_Remove.Enabled := false;
  btn_UT2003Dir.Enabled := false;
  threadsrunning := 0;
  totalcompress := 0;
  finished := 0;
  sb_Status.Panels[1].Text := 'Progress: 0%';
  sb_Status.Panels[2].Text := 'Compression: 0%';
  sb_Status.Panels[3].Text := 'Threads: 0';
  Application.Title := sb_Status.Panels[1].Text;
  Screen.Cursor := crAppStart;
  for i := 0 to lv_Files.Items.Count-1 do begin
    while (threadsrunning >= ud_MaxThreads.Position) do begin
      Application.ProcessMessages;
    end;
    j := 0;
    while ((threads[j] <> nil) and (j < MAXTHREADS)) do begin
      Inc(j);
      Application.ProcessMessages;
    end;
    if (threads[j] = nil) then begin
      threads[j] := TUCCThread.Create(lv_Files.Items[i].Caption, ucc);
      threads[j].threadid := j;
      Inc(threadsrunning);
      threads[j].OnTerminate := ThreadFinished;
      threads[j].Resume;
      updateThreadButton(j, true, lv_Files.Items[i].Caption);
      sb_Status.Panels[3].Text := 'Threads: '+IntToStr(threadsrunning);
    end;
  end;
end;

procedure Tfrm_Main.ae_MainHint(Sender: TObject);
begin
  sb_Status.SimpleText := Application.Hint;
  sb_status.SimplePanel := (Application.Hint <> '');
end;

procedure Tfrm_Main.FormShow(Sender: TObject);
var
  reg: TRegistry;
  tmp: string;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    if (reg.OpenKey('\Software\Unreal Technology\Installed Apps\UT2003', false)) then begin
      if (reg.ValueExists('Folder')) then begin
        tmp := reg.ReadString('Folder');
        if (FileExists(tmp+'\System\ucc.exe')) then ucc := tmp+'\System\ucc.exe';
        tv_explorer.Path := tmp;
      end;
    end;
    if (reg.OpenKey('\Software\TDS\UT2003 Compress', false)) then begin
      if (reg.ValueExists('MaxThreads')) then ud_MaxThreads.Position := reg.ReadInteger('MaxThreads');
      if (reg.ValueExists('SplitLeft')) then tv_Explorer.Width := reg.ReadInteger('SplitLeft');
      if (reg.ValueExists('SplitTop')) then pnl_Files.Height := reg.ReadInteger('SplitTop');
      if (reg.ValueExists('UCC')) then ucc := reg.ReadString('UCC');
      if (reg.ValueExists('UploadAfterCompress')) then frm_Upload.cb_UploadAfterCompress.Checked := reg.Readbool('UploadAfterCompress');

      if (reg.ValueExists('RS')) then frm_Upload.cb_RedirectSite.Checked := reg.ReadBool('RS');
      if (reg.ValueExists('RSHost')) then frm_Upload.ed_RSHost.Text := reg.ReadString('RSHost');
      if (reg.ValueExists('RSPort')) then frm_Upload.ed_RSPort.Text := reg.ReadString('RSPort');
      if (reg.ValueExists('RSDir')) then frm_Upload.ed_RSDir.Text := reg.ReadString('RSDir');
      if (reg.ValueExists('RSUser')) then frm_Upload.ed_RSUser.Text := reg.ReadString('RSUser');
      if (reg.ValueExists('RSPass')) then frm_Upload.ed_RSPass.Text := reg.ReadString('RSPass');

      if (reg.ValueExists('UT')) then frm_Upload.cb_UT2003Server.Checked := reg.ReadBool('UT');
      if (reg.ValueExists('UTHost')) then frm_Upload.ed_UTHost.Text := reg.ReadString('UTHost');
      if (reg.ValueExists('UTPort')) then frm_Upload.ed_UTPort.Text := reg.ReadString('UTPort');
      if (reg.ValueExists('UTDir')) then frm_Upload.ed_UTDir.Text := reg.ReadString('UTDir');
      if (reg.ValueExists('UTUser')) then frm_Upload.ed_UTUser.Text := reg.ReadString('UTUser');
      if (reg.ValueExists('UTPass')) then frm_Upload.ed_UTPass.Text := reg.ReadString('UTPass');
    end;
  finally
    reg.Free;
  end;
  if (not FileExists(ucc)) then btn_UT2003Dir.Font.Style := [fsBold]
    else btn_UT2003Dir.Font.Style := [];
end;

procedure Tfrm_Main.slv_ExplorerDblClick(Sender: TObject);
begin
  if (slv_Explorer.SelectedFolder.IsFolder) then
    tv_Explorer.Path := slv_Explorer.SelectedFolder.PathName
    else btn_AddClick(Sender);
end;

procedure Tfrm_Main.btn_ExitClick(Sender: TObject);
begin
  Close;
end;

procedure Tfrm_Main.FormClose(Sender: TObject; var Action: TCloseAction);
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    if (reg.OpenKey('\Software\TDS\UT2003 Compress', true)) then begin
      reg.WriteInteger('MaxThreads', ud_MaxThreads.Position);
      reg.WriteInteger('SplitLeft', tv_Explorer.Width);
      reg.WriteInteger('SplitTop', pnl_Files.Height);
      reg.WriteString('UCC', ucc);
      reg.WriteBool('UploadAfterCompress',frm_Upload.cb_UploadAfterCompress.Checked);

      reg.WriteBool('RS',frm_Upload.cb_RedirectSite.Checked);
      reg.WriteString('RSHost',frm_Upload.ed_RSHost.Text);
      reg.WriteString('RSPort',frm_Upload.ed_RSPort.Text);
      reg.WriteString('RSDir',frm_Upload.ed_RSDir.Text);
      reg.WriteString('RSUser',frm_Upload.ed_RSUser.Text);
      reg.WriteString('RSPass',frm_Upload.ed_RSPass.Text);

      reg.WriteBool('UT',frm_Upload.cb_UT2003Server.Checked);
      reg.WriteString('UTHost',frm_Upload.ed_UTHost.Text);
      reg.WriteString('UTPort',frm_Upload.ed_UTPort.Text);
      reg.WriteString('UTDir',frm_Upload.ed_UTDir.Text);
      reg.WriteString('UTUser',frm_Upload.ed_UTUser.Text);
      reg.WriteString('UTPass',frm_Upload.ed_UTPass.Text);
    end;
  finally
    reg.Free;
  end;
end;

procedure Tfrm_Main.slv_ExplorerKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F5) then slv_Explorer.Refresh;
end;

procedure Tfrm_Main.btn_Thread1Click(Sender: TObject);
begin
  AbortThread(0);
  btn_Thread1.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread2Click(Sender: TObject);
begin
  AbortThread(1);
  btn_Thread2.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread3Click(Sender: TObject);
begin
  AbortThread(2);
  btn_Thread3.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread4Click(Sender: TObject);
begin
  AbortThread(3);
  btn_Thread4.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread5Click(Sender: TObject);
begin
  AbortThread(4);
  btn_Thread5.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread6Click(Sender: TObject);
begin
  AbortThread(5);
  btn_Thread6.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread7Click(Sender: TObject);
begin
  AbortThread(6);
  btn_Thread7.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread8Click(Sender: TObject);
begin
  AbortThread(7);
  btn_Thread8.Enabled := false;
end;

procedure Tfrm_Main.btn_Thread9Click(Sender: TObject);
begin
  AbortThread(8);
  btn_Thread9.Enabled := false;
end;

procedure Tfrm_Main.btn_AbortClick(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to MAXTHREADS-1 do  AbortThread(i);
end;

procedure Tfrm_Main.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (working) then begin
    if MessageDlg('You are still compressing files.'+#13+#10+'Do you want to abort and exit UT2003Compress', mtWarning, [mbYes,mbNo], 0) = mrYes then begin
      btn_AbortClick(Sender);
    end
    else begin
      CanClose := false;
    end;
  end;
end;

procedure Tfrm_Main.Button1Click(Sender: TObject);
begin
  frm_Upload.ShowModal;
end;

procedure Tfrm_Main.btn_UploadSettingsClick(Sender: TObject);
begin
  frm_Upload.ShowModal;
end;

end.
